/*
 *  Copyright (C) 2008 Florent Bedoiseau (electronique.fb@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef ZXFILES_H
#define ZXFILES_H

#include <PA9.h>      
#include <fat.h>
#include <sys/dir.h>

#include <list>
#include <string>

#include "nogif.h"

class ZXFiles {
 public:
  ZXFiles (const std::string & rep);
  ~ZXFiles ();

  bool getGifFile (const std::string & sna, std::string &giffile);

  std::list<std::string> &getSna() { return _sna; }
  std::list<std::string> &getGif() { return _gif; }

 private:
  bool browseFiles ();
  std::list<std::string> _sna;
  std::list<std::string> _gif;
  std::string _repbase;
};

#endif
