/*
 *  Copyright (C) 2008 Florent Bedoiseau (electronique.fb@free.fr)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "ZXKeyboard.h"

u8 keys[4][10] = {
  { '1', '2', '3', '4', '5', '6', '7', '8', '9', '0' },
  { 'q', 'w', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p' },
  { 'a', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l', '\n' },
  { ZX_CAPS_SHIFT, 'z', 'x', 'c', 'v', 'b', 'n', 'm', ZX_SYMBOL_SHIFT, ' '}
};

ZXKeyboard::ZXKeyboard () {
}

ZXKeyboard::~ZXKeyboard () {
}

void ZXKeyboard::show() {
  PA_LoadGifXY(0, 0, ZX_KYBOARD_Y, (void*)keyboard);
}

void ZXKeyboard::hide() {
  PA_Clear16bitBg(0);
}

u8 ZXKeyboard::getKey () {
  if (Stylus.Held) {
	u8 ligne=0;
	u8 colonne=0;
	u16 x = Stylus.X;
	u16 y = Stylus.Y - ZX_KYBOARD_Y;
	if (y>=17 && y<=27) ligne = 0;
	else if (y>=41 && y<=51) ligne = 1;
	else if (y>=65 && y<=75) ligne = 2;
	else if (y>=89 && y<=99) ligne = 3;
	else return 0;
	
	if (ligne == 0) {
	  if (x>=6 && x<=234) {
		colonne = (x-6)/23;
	  }
	}
	else if (ligne == 1) {
	  if (x>=18 && x<=245) {
		colonne = (x-18)/23;
	  }
	}
	else if (ligne == 2) {
	  if (x>=23 && x<=250) {
		colonne = (x-23)/23;
	  }
	}
	else if (ligne == 3) {
	  if (x>=6 && x<=250) {
		colonne = (x-6)/24;
	  }
	}
	else return 0;
	
	if (ligne<4 && colonne < 10) {
	  PA_PlaySimpleSound(1, bip); // Canal 1
	  return keys[ligne][colonne];
	}
  }

  return 0;
}
