#ifndef PA9_H
#define PA9_H

#include <stdlib.h>
#include <stdio.h>

typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned int u32;
typedef short s16;
typedef char s8;
typedef int s32;

u32 PA_Rand();
void PA_Init16bitBg(u8 screen, u8 prio);
void fatInitDefault();
void PA_Init();
void PA_InitVBL();
void PA_InitSound ();
void PA_InitKeyboard (u8 bg_number);
void PA_InitText (u8 screen, u8 bg_select);
void PA_SplashBlue();
void PA_Clear16bitBg (u8 screen);
void PA_WaitForVBL();
char PA_CheckKeyboard();
void PA_KeyboardIn (s16 x, s16 y);
void PA_Put16bitPixel (u8 screen, s16 x, s16 y, u16 color);
u16 PA_OutputSimpleText (u8 screen, u16 x, u16 y, const char *text);
void PA_OutputText (u8 screen, u16 x, u16 y, char * text, ...);
void PA_SetTextCol (u8 screen, u16 r, u16 g, u16 b);
void PA_SetBgPalCol (u8 screen, u8 color_number, s16 colorRGB );
u16 PA_RGB (u8 r, u8 g, u8 b);
void PA_StopSound (u8 c);
void PA_PlaySound (u8 PA_Channel, const s8 *data, s32 length, u8 volume, u32 freq);
void PA_LoadGifXY (u8 s, u8 x, u8 y, void *);

typedef struct _Pad {
  struct { u8 Left, Right, Up, Down, A, X, Start, Select, R; } Held;
  struct { u8 Left, Right, Up, Down, A, X, Start, Select, R; } Newpress;
  struct { u8 Left, Right, Up, Down, A, X, Start, Select, R; } Released;
} PAD;

typedef struct _Stylus {
  u8 Held;
  u8 Newpress;
  u16 X;
  u16 Y;
} STYLUS;

typedef struct _Rtc {
  u8 FPS;
} RTC;

#define PA_BACKSPACE 0

extern PAD Pad;
extern STYLUS Stylus;
extern RTC PA_RTC;
#endif
